module Bindep
  # Get the global context instance, create a new one on first call.
  def self.context
    @context ||= Context.new
  end

  # Evaluate a Bindepfile in the global context.
  def self.load_file(filename = 'Bindepfile')
    context.instance_eval File.read(filename)
  end

  # Redirect all other method calls to the global context instance.
  def self.method_missing(method, *args, &block)        
    context.send method, *args, &block
  end
end
