module Bindep
  module OS
    LIST = {
      :brew => "brew install",  
      :apt => "apt-get install -y",  
      :yum => "yum install -y",  
      :npm => "npm install -g",
      :rubygem => "gem install",
    }
    @command_exists_cache = {}

    class << self
      LIST.each_pair do |method, install_cmd|
        check_cmd = install_cmd.split(" ").first

        # Create a "handler?" method which checks if the specified package handler is available.
        define_method("#{method}?") do 
          return @command_exists_cache[method] unless @command_exists_cache[method].nil?
          @command_exists_cache[method] = Helpers.command_exists? check_cmd
        end

        # Create a "handler_install" method which returns the install string for the given handler.
        define_method("#{method}_install") do |package| 
          "#{sudo} #{install_cmd} #{package}".strip
        end
      end
    end

    private
    def self.sudo
      # homebrew does not need sudo for itself and other package managers
      brew? ? "" : "sudo"
    end
  end
end
